/****************************************************************************\
  FILE..........: plg_std.h
  AUTHOR........: bsm
  COPYRIGHT.....: Copyright (c) 2002
  VERSION.......: 1.00
  DESCRIPTION...: The module conatains definition of

  HISTORY.......: DATE     COMMENT
                  -------- ------------------------------------------------
                  04-07-02 Created.
\****************************************************************************/

/*===========================================[ REDEFINITION DEFENCE ]=======*/
#ifndef PLG_STD_H
#define PLG_STD_H

/*===========================================[ IMPORT DECLARATIONS ]========*/
#include "plg_supp.h"

/*===========================================[ SPECIAL ]====================*/
#ifdef __cplusplus
	extern "C" {
#endif

/*===========================================[ VERSION ]====================*/
/*===========================================[ PUBLIC MACROS ]==============*/
/*===========================================[ PUBLIC CONSTANTS ]===========*/
/*===========================================[ PUBLIC TYPES ]===============*/
/*===========================================[ PUBLIC VARIABLES ]===========*/
/*===========================================[ PUBLIC FUNCTIONS ]===========*/

/*
**   Win32.Sleep()
*/
STK_FUNC_VOID stdSleep(
	STK_PARAM_INT iMilliseconds  // IN
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**   Win32.GetTickCount()
*/
STK_FUNC_INT stdGetTickCount(
	STK_PLUGIN_EXEC_PARAMS(iSrcLine, pStkPrj)
	);

/*
**   sprintf(sFormat, dValue)
*/
STK_FUNC_STRING stdFtoS(
	STK_PARAM_STRING sFormat,  // IN
	STK_PARAM_FLOAT  dValue    // IN
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**   sprintf(sFormat, iValue)
*/
STK_FUNC_STRING stdItoS(
	STK_PARAM_STRING sFormat,  // IN
	STK_PARAM_INT    iValue    // IN
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**   sin()
*/
STK_FUNC_FLOAT stdSin(
	STK_PARAM_FLOAT f
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**   cos()
*/
STK_FUNC_FLOAT stdCos(
	STK_PARAM_FLOAT f
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  float->int
*/
STK_FUNC_INT stdInt(
	STK_PARAM_FLOAT f
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  int->float
*/
STK_FUNC_FLOAT stdFloat(
	STK_PARAM_INT   i
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  pow(base, ext),     float
*/
STK_FUNC_FLOAT stdDegreeF(
	STK_PARAM_FLOAT   base,
	STK_PARAM_FLOAT   ext
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  pow(base, ext),     int
*/
STK_FUNC_INT stdDegreeI(
	STK_PARAM_INT   base,
	STK_PARAM_INT   ext
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  sqrt(value),     float
*/
STK_FUNC_FLOAT stdSqrtF(
	STK_PARAM_FLOAT value
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  sqrt(value),     int
*/
STK_FUNC_INT stdSqrtI(
	STK_PARAM_INT   value
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  atoi(s)
*/
STK_FUNC_INT stdAtoi(
	STK_PARAM_STRING s
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  atof(s)
*/
STK_FUNC_FLOAT stdAtof(
	STK_PARAM_STRING s
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  stdFtoS("%f", val)
*/
STK_FUNC_STRING stdFtoA(
	STK_PARAM_FLOAT val
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  stdItoS("%d", val)
*/
STK_FUNC_STRING stdItoA(
	STK_PARAM_INT val
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  rand(),  bTimeSeed==1   srand((unsigned)time(NULL))
*/
STK_FUNC_INT stdRandom(
	STK_PARAM_INT bTimeSeed
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  Win32.MessageBox()
** 
** 'mode' -       ( . 'akm_defs.h')
** returns:
**  (int) -  ,   ( . 'akm_defs.h')
*/
STK_FUNC_INT stdMessageBox(
	STK_PARAM_STRING msg,
	STK_PARAM_STRING title,
	STK_PARAM_INT mode
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  time(NULL)
*/
STK_FUNC_INT stdTimeGetSec(
	STK_PLUGIN_EXEC_PARAMS(iSrcLine, pStkPrj)
	);

/*
** The 'format' argument consists of one or more codes; as in printf,
**   the formatting codes are preceded by a percent sign (%). Characters
**   that do not begin with % are copied unchanged to output. 
**
**   The formatting codes for strftime are listed below:
**   %a - Abbreviated weekday name
**   %A - Full weekday name
**   %b - Abbreviated month name
**   %B - Full month name
**   %c - Date and time representation appropriate for locale
**   %d - Day of month as decimal number (01  31)
**   %H - Hour in 24-hour format (00  23)
**   %I - Hour in 12-hour format (01  12)
**   %j - Day of year as decimal number (001  366)
**   %m - Month as decimal number (01  12)
**   %M - Minute as decimal number (00  59)
**   %p - Current locales A.M./P.M. indicator for 12-hour clock
**   %S - Second as decimal number (00  59)
**   %U - Week of year as decimal number, with Sunday as first day of week (00  53)
**   %w - Weekday as decimal number (0  6; Sunday is 0)
**   %W - Week of year as decimal number, with Monday as first day of week (00  53)
**   %x - Date representation for current locale
**   %X - Time representation for current locale
**   %y - Year without century, as decimal number (00  99)
**   %Y - Year with century, as decimal number
**   %z, %Z - Time-zone name or abbreviation; no characters if time zone is unknown
**   %% - Percent sign
**
**   As in the printf function, the # flag may prefix any formatting code. In
**   that case, the meaning of the format code is changed as follows.
**   Format Code Meaning 
**   %#a, %#A, %#b, %#B, %#p, %#X, %#z, %#Z, %#% - # flag is ignored. 
**   %#c - Long date and time representation, appropriate for current locale.
**         For example: Tuesday, March 14, 1995, 12:41:29. 
**   %#x - Long date representation, appropriate to current locale. 
**         For example: Tuesday, March 14, 1995. 
**   %#d, %#H, %#I, %#j, %#m, %#M, %#S, %#U, %#w, %#W, %#y, %#Y - Remove leading zeros (if any). 
**
**   timeSec==0    
*/
STK_FUNC_STRING stdTimeFormat(
	STK_PARAM_STRING format,
	STK_PARAM_INT    timeSec
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  stdTimeFormat("%H:%M:%S-%d:%m:%Y", timeSec)
*/
STK_FUNC_STRING stdTimeFormatSec(
	STK_PARAM_INT timeSec
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**     MM:SS.CCC
*/
STK_FUNC_STRING stdTimeFormatMs(
	STK_PARAM_INT timeMs
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  strcmp(s1, s2)
*/
STK_FUNC_INT stdStrCmp(
	STK_PARAM_STRING s1,
	STK_PARAM_STRING s2
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**  strstr(str, sfnd),      -1
*/
STK_FUNC_INT stdStrStr(
	STK_PARAM_STRING str,
	STK_PARAM_STRING sfnd
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**      'begin'  'length'
*/
STK_FUNC_STRING stdStrSub(
	STK_PARAM_STRING str,
	STK_PARAM_INT begin,
	STK_PARAM_INT length
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**        
**    'begin'  'length'
*/
STK_FUNC_STRING stdStrDel(
	STK_PARAM_STRING str,
	STK_PARAM_INT begin,
	STK_PARAM_INT length
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**      'strIns'    'begin'
*/
STK_FUNC_STRING stdStrIns(
	STK_PARAM_STRING str,
	STK_PARAM_INT begin,
	STK_PARAM_STRING strIns
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**     str[index],  -1    
*/
STK_FUNC_INT stdStrGetChar(
	STK_PARAM_STRING str,
	STK_PARAM_INT index
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**          'index' 
**     'scahr'
*/
STK_FUNC_STRING stdStrSetChar(
	STK_PARAM_STRING str,
	STK_PARAM_INT index,
	STK_PARAM_INT schar
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**   strlen(str)
*/
STK_FUNC_INT stdStrLen(
	STK_PARAM_STRING str
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);

/*
**        
**    iarray[start..start+length]
*/
STK_FUNC_STRING stdStrFromArray(
	STK_PARAM_INT iarray[101],
	STK_PARAM_INT start,
	STK_PARAM_INT length
	STK_PLUGIN_EXEC_PARAM(iSrcLine, pStkPrj)
	);


/*===========================================[ PSEUDO/INLINE FUNCTIONS ]====*/
/*===========================================[ SPECIAL ]====================*/
#ifdef __cplusplus
	}  /* extern "C" { */
#endif

/*===========================================[ END REDEFINITION DEFENCE ]===*/

#endif /* PLG_STD_H */

/** (END OF FILE  : plg_std.h) **********************************************/
